## fenics-basix 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# Set the version
project(Basix VERSION "0.3.0" LANGUAGES CXX)
include(GNUInstallDirs)

include(FeatureSummary)

# Enable SIMD with xtensor
option(XTENSOR_USE_XSIMD "Enable SIMD with xtensor" OFF)
add_feature_info(XTENSOR_USE_XSIMD XTENSOR_USE_XSIMD "Enable SIMD with xtensor.")

# Enable xtensor with target-specific optimization, i.e. -march=native
option(XTENSOR_OPTIMIZE "Enable xtensor target-specific optimization" OFF)
add_feature_info(XTENSOR_OPTIMIZE XTENSOR_OPTIMIZE "Enable architecture-specific optimizations as defined by xtensor.")

# Set the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Options
option(BUILD_SHARED_LIBS "Build Basix with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build Basix with shared libraries.")

# Find dependecies
set(XTENSOR_MIN_VERSION 0.23.10)
set(XTL_MIN_VERSION 0.7.0)
set(XSIMD_MIN_VERSION 7.4.10)

include(FetchContent)

# xsimd (optional)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
  find_package(xsimd ${XSIMD_MIN_VERSION}...<8.0 QUIET)
else()
  find_package(xsimd ${XSIMD_MIN_VERSION} QUIET)
endif()
if(XTENSOR_USE_XSIMD AND NOT xsimd_FOUND)
  message("downloading xsimd source...")
  FetchContent_Declare(
    xsimd
    GIT_REPOSITORY https://github.com/xtensor-stack/xsimd.git
    GIT_TAG        7.4.10
  )
  FetchContent_MakeAvailable(xsimd)
else()
  message("found xsimd ${xsimd_VERSION}")
endif()

# xtl, xtensor, xtensor-blas (required)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
  find_package(xtl ${XTL_MIN_VERSION}...<0.8 QUIET)
  find_package(xtensor ${XTENSOR_MIN_VERSION}...<0.24 QUIET)
else()
  find_package(xtl ${XTL_MIN_VERSION} QUIET)
  find_package(xtensor ${XTENSOR_MIN_VERSION} QUIET)
endif()
find_package(xtensor-blas 0.19 QUIET)
if(NOT xtl_FOUND)
  message("downloading xtl source...")
  FetchContent_Declare(
    xtl
    GIT_REPOSITORY https://github.com/xtensor-stack/xtl.git
    GIT_TAG        0.7.2
  )
  FetchContent_MakeAvailable(xtl)
else()
  message("found xtl ${xtl_VERSION}")
endif()
if(NOT xtensor_FOUND)
  message("downloading xtensor source...")
  FetchContent_Declare(
    xtensor
    GIT_REPOSITORY https://github.com/xtensor-stack/xtensor.git
    GIT_TAG        0.23.10
  )
  FetchContent_MakeAvailable(xtensor)
else()
  message("found xtensor ${xtensor_VERSION}")
endif()
if(NOT xtensor-blas_FOUND)
  message("downloading xtensor-blas source...")
  FetchContent_Declare(
    xtensor_blas
    GIT_REPOSITORY https://github.com/xtensor-stack/xtensor-blas.git
    GIT_TAG        0.19.1
  )
  FetchContent_MakeAvailable(xtensor_blas)
else()
  message("found xtensor-blas ${xtensor-blas_VERSION}")
endif()

find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)

feature_summary(WHAT ALL)

# --Source files

add_library(basix)

configure_file(${CMAKE_SOURCE_DIR}/cpp/basix/version.h.in ${CMAKE_SOURCE_DIR}/cpp/basix/version.h)

set(HEADERS_basix
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/cell.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/dof-transformations.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/element-families.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/finite-element.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/indexing.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/lattice.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/log.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/maps.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/moments.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/polyset.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/precompute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/quadrature.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/lagrange.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/nce-rtc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/brezzi-douglas-marini.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/nedelec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/raviart-thomas.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/regge.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/crouzeix-raviart.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/bubble.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/serendipity.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/version.h)

target_sources(basix PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/cell.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/dof-transformations.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/element-families.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/finite-element.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/lattice.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/maps.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/moments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/polyset.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/precompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/quadrature.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/lagrange.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/nce-rtc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/brezzi-douglas-marini.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/nedelec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/raviart-thomas.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/regge.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/crouzeix-raviart.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/bubble.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp/basix/serendipity.cpp)

# Configure the library
set_target_properties(basix PROPERTIES PUBLIC_HEADER cpp/basix/finite-element.h)
set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
target_include_directories(basix PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/cpp>")

# The commented lines need CMake >= 3.18
# target_link_libraries(basix PRIVATE BLAS::BLAS)
# target_link_libraries(basix PRIVATE LAPACK::LAPACK)
target_link_libraries(basix PRIVATE ${BLAS_LIBRARIES})
target_link_libraries(basix PRIVATE ${LAPACK_LIBRARIES})

# xtensor and related packages
target_link_libraries(basix PUBLIC xtl)

# Note: we use get_target_property/set_target_properties to ensure that
# that -isystem flag is applied to allow us to use strict compiler flags
get_target_property(XTENSOR_INC_SYS xtensor INTERFACE_INCLUDE_DIRECTORIES)
set_target_properties(xtensor PROPERTIES INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${XTENSOR_INC_SYS}")
target_link_libraries(basix PUBLIC xtensor)

# Add xsimd definition to Basix so that Basix will export this option so
# that other libraries will know that Basix was compiled with xsimd
get_target_property(XTENSOR_DEFN xtensor INTERFACE_COMPILE_DEFINITIONS)
if("XTENSOR_USE_XSIMD" IN_LIST XTENSOR_DEFN)
  target_compile_definitions(basix PUBLIC XTENSOR_USE_XSIMD)
elseif(TARGET xsimd AND XTENSOR_USE_XSIMD)
  target_compile_definitions(basix PUBLIC XTENSOR_USE_XSIMD)
  target_link_libraries(basix PRIVATE xsimd)
endif()

# Handle -march=native
if (XTENSOR_OPTIMIZE AND TARGET xtensor::optimize)
  target_link_libraries(basix PUBLIC xtensor::optimize)
elseif(XTENSOR_OPTIMIZE)
  target_compile_options(basix PUBLIC -march=native)
endif()

# Note: we use get_target_property/set_target_properties to ensure that
# that -isystem flag is applied to allow us to use strict compiler flags
get_target_property(XTENSORBLAS_INC_SYS xtensor-blas INTERFACE_INCLUDE_DIRECTORIES)
set_target_properties(xtensor-blas PROPERTIES INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${XTENSORBLAS_INC_SYS}")
target_link_libraries(basix PRIVATE xtensor-blas)

# Set compiler flags
list(APPEND BASIX_DEVELOPER_FLAGS -O2;-g;-pipe)
list(APPEND basix_compiler_flags -Wall;-Werror;-Wextra;-Wno-comment;-pedantic;)
target_compile_options(basix PRIVATE "$<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:${basix_compiler_flags}>")
target_compile_options(basix PRIVATE $<$<CONFIG:Developer>:${BASIX_DEVELOPER_FLAGS}>)

# Set debug definitions (private)
target_compile_definitions(basix PRIVATE $<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:DEBUG>)

# Install the Basix library
install(TARGETS basix
  EXPORT BasixTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development)

# Install CMake helpers
include(CMakePackageConfigHelpers)
write_basic_package_version_file(BasixConfigVersion.cmake VERSION ${PACKAGE_VERSION} COMPATIBILITY AnyNewerVersion)
configure_package_config_file(BasixConfig.cmake.in ${CMAKE_BINARY_DIR}/BasixConfig.cmake INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

install(FILES ${CMAKE_BINARY_DIR}/BasixConfig.cmake ${CMAKE_BINARY_DIR}/BasixConfigVersion.cmake
        DESTINATION  ${CMAKE_INSTALL_LIBDIR}/cmake/basix COMPONENT Development)
install(EXPORT BasixTargets FILE BasixTargets.cmake NAMESPACE Basix:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

PROJECT(basix_pybind11 VERSION "0.0.1")

# Set C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Find Basix (C++)
find_package(Basix REQUIRED)

# Check if the Basix C++ library was compiled with xtensor SIMD
get_target_property(BASIX_DEFN Basix::basix INTERFACE_COMPILE_DEFINITIONS)
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN)
  find_package(xsimd REQUIRED)
endif()

# include(FetchContent)
# FetchContent_Declare(
#   basix
#   GIT_REPOSITORY https://github.com/FEniCS/basix.git
#   GIT_TAG        xtensor
# )
# FetchContent_MakeAvailable(basix)
# get_target_property(_basix_include_dirs basix INTERFACE_INCLUDE_DIRECTORIES)
# target_include_directories(basix SYSTEM PRIVATE ${_basix_include_dirs})

find_package(pybind11 REQUIRED CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})

# Create the binding library
pybind11_add_module(_basixcpp SHARED wrapper.cpp)
target_link_libraries(_basixcpp PRIVATE pybind11::module)
target_link_libraries(_basixcpp PRIVATE Basix::basix)

# Add xsimd if the Basix C++ interface was compiled with it
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN)
  target_link_libraries(_basixcpp PRIVATE xsimd)
endif()

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror  -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment;-pedantic)
endif()

# In Debug mode override pybind11 symbols visibility Symbols must be
# visible to backtrace_symbols() to produce nice logs
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  target_compile_options(_basixcpp PRIVATE "-fvisibility=default")
endif()

=== doc/python/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -W
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Basix
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
fenics-basix (0.3.0-11build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 22:37:22 +0000

fenics-basix (0.3.0-11) unstable; urgency=medium

  * debian patch build_any_xtensor.patch allows building against more
    recent xtensor (and xsimd) versions. Removes xsimd detection
    (which is performed by the xtensor config files)
    cf. https://github.com/FEniCS/basix/issues/348
    - make xtl, xtensor, xtensor-blas required (don't fetch source)

 -- Drew Parsons <dparsons@debian.org>  Thu, 02 Dec 2021 17:19:37 +0100

fenics-basix (0.3.0-10) unstable; urgency=medium

  * skip numba tests on mipsel
  * debian patch reproducible_docs.diff makes the doc build
    reproducible. Thanks Chris Lamb. Closes: #996999.

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Oct 2021 18:06:12 +0200

fenics-basix (0.3.0-9) unstable; urgency=medium

  * drop arm64 from xsimd-supported arch list. xsimd fails tests on
    arm64 (see also xtensor xsimd support)

 -- Drew Parsons <dparsons@debian.org>  Thu, 21 Oct 2021 00:02:29 +0200

fenics-basix (0.3.0-8) experimental; urgency=medium

  * fix skip_flaky_arch_numba_tests.patch to import pytest first.
    Rename skip_armel_numba_tests.py as skip_flaky_arch_numba_tests.patch

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 19:15:37 +0200

fenics-basix (0.3.0-7) experimental; urgency=medium

  * rename debian patch skip_armel_numba_tests.py to
    skip_flaky_arch_numba_tests.py, and add s390x, ppc64 alongside
    armel as arches for which numba is available but not reliable.
    Skip these arches before testing if numba is available
    (test_numba_conditional.patch) since even just loading numba can
    trigger a segfault on these arches.

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 17:27:19 +0200

fenics-basix (0.3.0-6) experimental; urgency=medium

  * debian patch test_numba_conditional.patch skips test_numba.py if
    numba cannot be imported (it's not available on all arches).
  * explicitly switch xsimd support off except for arches where it
    is known to work (amd64, arm64; kfreebsd is untested).
    libxsimd-dev is available on some arches such as i386, m68k,
    but no xsimd instructions are actually available which causes
    problems with the basix build (warnings are treated as errors)

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 13:49:30 +0200

fenics-basix (0.3.0-5) experimental; urgency=medium

  * remove m68k, sh4 from xsimd list. They don't actually have any
    xsimd instructions (same problem as i386).
  * build python docs in arch-independent build
  * python3-basix Recommends: python3-numba

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 09:23:47 +0200

fenics-basix (0.3.0-4) experimental; urgency=medium

  * use numba only where available. Build-Depends: python3-numba
    [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64]
  * add :any to Build-Depends: python3-all-dev:any

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Oct 2021 23:46:02 +0200

fenics-basix (0.3.0-3) experimental; urgency=medium

  * debian patch skip_armel_numba_tests.py skips numba tests on armel
    (armv7l). Numba is flakey on armel, see Bug#994294.

 -- Drew Parsons <dparsons@debian.org>  Fri, 01 Oct 2021 16:33:35 +0200

fenics-basix (0.3.0-2) experimental; urgency=medium

  * drop x86 arches (i386 hurd-i386 x32) from xsimd support,
    tracking support in xtensor.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Sep 2021 00:11:30 +0200

fenics-basix (0.3.0-1) experimental; urgency=medium

  * New upstream release.
    - dirs updated from basix/cpp to cpp/basix
    - source docs moved to doc subdir
  * Standards-Version: 4.6.0
  * Build with xsimd support (-DXTENSOR_USE_XSIMD=ON) where available
    Build-Depends: libxsimd-dev (>= 7.4.10~)
    [amd64 arm64 i386 hurd-i386 kfreebsd-any m68k sh4 x32]
  * debian patch fix_doc_build.patch fixes doc configuration
    (header.html changed to header.html.template)
    Needs doxygen -u to update obsolete tags.

 -- Drew Parsons <dparsons@debian.org>  Thu, 09 Sep 2021 03:19:20 +0300

fenics-basix (0.1.0-1) experimental; urgency=medium

  * update source package name to fenics-basix
    - update Vcs salsa paths
  * First official upstream release.
    - Build-Depends: xtl-dev (>= 0.7.0~)
    - Build-Depends: python3-numba (for tests)
    - deprecates debian patch include_path.patch
  * versioned Build-Depends: libxtensor-blas-dev (>= 0.19~)
  * update xtensor Build-Depends to libxtensor-dev
  * debian/rules clean removes basix/cpp/basix/version.h and
    python/build if present
  * run python tests using install dir not build dir

 -- Drew Parsons <dparsons@debian.org>  Thu, 27 May 2021 15:38:37 +0200

basix (0.0.1~git20210409.b980196-2) experimental; urgency=medium

  * provide python docs in basix-docs (built using sphinx)
    - doc-base points at python docs, index.html links to C++ docs
  * skip build-time tests if nocheck is set in DEB_BUILD_OPTIONS
  * override_dh_auto_clean removes python build and test dirs and
    generated cpp/docs

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Apr 2021 21:31:37 +0200

basix (0.0.1~git20210409.b980196-1) experimental; urgency=medium

  * New upstream snapshot.
    - uses xtensor and drops skbuild
  * Build-Depends: xtensor-dev (>= 0.23.4~), xtensor-blas-dev
    - xtensor-dev 0.23 implies xtl-dev (>= 0.7.0~), which is also
      required by basix (in CMakeLists.txt), but not used directly.
  * versioned Build-Depends: cmake (>= 3.16), xtensor-dev (>= 0.23~)
  * drop debian patch test_permutation_nedelec_32bit_xfail.patch
    (obsolete, test_permutations.py no longer exists)
  * add debian patches
    - skip_runpath.patch keeps RPATH from being injected into libraries
      built by cmake (in particular the python extension library)
    - find_generic_blas.patch instructs cmake to find generic libblas.so


=== debian/control ===
Source: fenics-basix
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-all-dev:any,
 python3-fiat,
 python3-numba [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64],
 python3-numpy,
 python3-pybind11 (>= 2.6.0~),
 python3-pytest,
 python3-sphinx,
 python3-sympy,
 python3-wheel,
 cmake (>= 3.16),
 chrpath,
 cython3,
 libeigen3-dev,
 libjs-mathjax,
 ninja-build,
 libxtensor-dev (>= 0.23.4~),
 libxtensor-blas-dev (>= 0.19~),
 libxsimd-dev (>= 7.4.10~) [amd64 kfreebsd-any],
 xtl-dev (>= 0.7.0~)
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.6.0
Homepage: https://github.com/FEniCS/basix
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: libbasix-dev
Architecture: any
Multi-Arch: same
Depends: libbasix0 (= ${binary:Version}),
 libeigen3-dev,
 ${misc:Depends}, ${shlibs:Depends}
Suggests: python3-basix, basix-doc
Description: Finite Element Basis Function Definition Runtime Library (development headers)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the development files for the shared library.

Package: libbasix0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the shared library.

Package: python3-basix
Architecture: any
Depends: libbasix-dev  (= ${binary:Version}),
 ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-numba
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the library for Python 3.

Package: basix-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${sphinxdoc:Depends}, ${misc:Depends}
Suggests: python3-basix
Description: Finite Element Basis Function Definition Runtime Library (docs)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_HOST_MULTIARCH

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

VERSION := $(DEB_STRIPPED_UPSTREAM_VERSION)
MAJOR_VERSION := $(shell echo $(DEB_STRIPPED_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
SOVERSION := $(MAJOR_VERSION)

PY3VERS := $(shell py3versions -v --requested debian/control | tac -s' ')
PY3VER_DEFAULT := $(shell py3versions -dv)

empty :=
space := $(empty)$(empty)

# libxsimd-dev is available on some arches such as i386, m68k,
# but no xsimd instructions are actually available which causes problems
# with the basix build (warnings are treated as errors)
# So explicitly switch xsimd support off except for arches where it is known to work.
XSIMD_ARCH_LIST := amd64 kfreebsd
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(XSIMD_ARCH_LIST)$(space)))
  XSIMD_CONFIG = -DXTENSOR_USE_XSIMD=ON
else
  XSIMD_CONFIG = -DXTENSOR_USE_XSIMD=OFF
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),mipsel))
  PYTEST_OPTIONS = -k "not numba"
endif


%:
	dh $@ --with python3,sphinxdoc --buildsystem=cmake


override_dh_auto_clean:
	rm -rf cpp/basix/version.h
	rm -rf doc/cpp/html doc/cpp/latex
	rm -rf .pybuild
	rm -rf python/build
	rm -rf python/fenics_basix.egg-info
	rm -rf doc/python/build
	rm -rf test/.pytest_cache  test/__pycache__  python/testing_build
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- $(XSIMD_CONFIG)

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build -i
	cd doc/cpp; doxygen

override_dh_auto_install-arch:
	dh_auto_install
	for v in $(PY3VERS); do \
	  echo cd python; \
	  LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake  pybuild --dir=$(CURDIR)/python --install --system=distutils --name=basix; \
	  cd ..; \
	done

override_dh_auto_install-indep: override_dh_auto_install-arch
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} $(MAKE) -C doc/python html
	sed 's|href="https://fenicsproject.org/docs/basix/main/cpp/"|href="file:/usr/share/doc/basix-doc/cpp/index.html"|' -i doc/python/build/html/index.html

override_dh_installdocs-indep:
	dh_installdocs -i
	grep "https://cdnjs.cloudflare.com/ajax/libs/mathjax/.*/MathJax.js" debian/basix-doc/usr/share/doc/basix-doc/* -r --files-with-matches | xargs sed "s|src=\"https://cdnjs.cloudflare.com/ajax/libs/mathjax/.*/MathJax.js|src=\"file://usr/share/javascript/mathjax/MathJax.js|g" -i

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_python3:
	cd test; LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} pytest-3 $(PYTEST_OPTIONS)
	dh_python3
endif

=== debian/tests/control ===
Test-Command: pytest-3
Depends: python3-basix,
 python3-pytest,
 python3-fiat,
 python3-numba [amd64 arm64 armel armhf i386 mips64el ppc64el s390x ppc64],
 python3-numpy,
 python3-sympy

## fenics-basix 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(BasixFull VERSION "0.4.2" LANGUAGES CXX)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# Set the version
project(Basix VERSION "0.4.2" LANGUAGES CXX)
include(GNUInstallDirs)

if (SKBUILD)
  # Always use lib/ in the Python root. Otherwise, environment used for
  # wheels might place in lib64/, which CMake on some systems will not
  # find.
  set(CMAKE_INSTALL_LIBDIR lib)
endif()

include(FeatureSummary)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Options
option(BUILD_SHARED_LIBS "Build Basix with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build Basix with shared libraries.")

# Download xtl and xtensor
option(DOWNLOAD_XTENSOR_LIBS "Download xtl and xtensor. Requires git." OFF)
add_feature_info(DOWNLOAD_XTENSOR_LIBS DOWNLOAD_XTENSOR_LIBS "Download xtl and xtensor. Requires git.")

# Enable xtensor with target-specific optimization, ie -march=native
option(XTENSOR_OPTIMIZE "Enable xtensor target-specific optimization" OFF)
add_feature_info(XTENSOR_OPTIMIZE XTENSOR_OPTIMIZE "Enable architecture-specific optimizations as defined by xtensor.")

# Find dependecies
set(XTENSOR_MIN_VERSION 0.23.10)
set(XTL_MIN_VERSION 0.7.0)

include(FetchContent)

if(NOT DOWNLOAD_XTENSOR_LIBS)
  # xtl, xtensor (required)
  if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
    find_package(xtl ${XTL_MIN_VERSION}...<0.8 REQUIRED)
    find_package(xtensor ${XTENSOR_MIN_VERSION}...<0.25 REQUIRED)
  else()
    find_package(xtl ${XTL_MIN_VERSION} REQUIRED)
    find_package(xtensor ${XTENSOR_MIN_VERSION} REQUIRED)
  endif()
else()
  message("Downloading xtl source...")
  FetchContent_Declare(
    xtl
    GIT_REPOSITORY https://github.com/xtensor-stack/xtl.git
    GIT_TAG        0.7.4
  )
  FetchContent_MakeAvailable(xtl)

  message("Downloading xtensor source...")
  FetchContent_Declare(
    xtensor
    GIT_REPOSITORY https://github.com/xtensor-stack/xtensor.git
    GIT_TAG        0.24.2
  )
  FetchContent_MakeAvailable(xtensor)
endif()

find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)

feature_summary(WHAT ALL)

# Source files

add_library(basix)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/basix/version.h.in basix/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(HEADERS_basix
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/element-families.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/indexing.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/log.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/maps.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.h
  ${CMAKE_CURRENT_BINARY_DIR}/basix/version.h)

target_sources(basix PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.cpp)

# Configure the library
set_target_properties(basix PROPERTIES PUBLIC_HEADER basix/finite-element.h)
set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
target_include_directories(basix PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}>")

# The commented lines need CMake >= 3.18
# target_link_libraries(basix PRIVATE BLAS::BLAS)
# target_link_libraries(basix PRIVATE LAPACK::LAPACK)
target_link_libraries(basix PRIVATE ${BLAS_LIBRARIES})
target_link_libraries(basix PRIVATE ${LAPACK_LIBRARIES})

# xtensor and related packages
target_link_libraries(basix PUBLIC xtl)

# Note: we use get_target_property/set_target_properties to ensure that
# that -isystem flag is applied to allow us to use strict compiler flags
get_target_property(XTENSOR_INC_SYS xtensor INTERFACE_INCLUDE_DIRECTORIES)
set_target_properties(xtensor PROPERTIES INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${XTENSOR_INC_SYS}")
target_link_libraries(basix PUBLIC xtensor)

# Handle -march=native
if (XTENSOR_OPTIMIZE AND TARGET xtensor::optimize)
  target_link_libraries(basix PUBLIC xtensor::optimize)
elseif(XTENSOR_OPTIMIZE)
  target_compile_options(basix PUBLIC -march=native)
endif()

# Set compiler flags
list(APPEND BASIX_DEVELOPER_FLAGS -O2;-g;-pipe)
list(APPEND basix_compiler_flags -Wall;-Werror;-Wextra;-Wno-comment;-pedantic;)
target_compile_options(basix PRIVATE "$<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:${basix_compiler_flags}>")
target_compile_options(basix PRIVATE $<$<CONFIG:Developer>:${BASIX_DEVELOPER_FLAGS}>)

# Install the Basix library
install(TARGETS basix
  EXPORT BasixTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development)

# Configure CMake helpers
include(CMakePackageConfigHelpers)
write_basic_package_version_file(BasixConfigVersion.cmake VERSION ${PACKAGE_VERSION}
  COMPATIBILITY AnyNewerVersion)
configure_package_config_file(BasixConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

# Install CMake files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/BasixConfigVersion.cmake
  DESTINATION  ${CMAKE_INSTALL_LIBDIR}/cmake/basix COMPONENT Development)
install(EXPORT BasixTargets FILE BasixTargets.cmake NAMESPACE Basix::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

PROJECT(basix_pybind11 VERSION "0.4.2"  LANGUAGES CXX)

# Set C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# See https://gitlab.kitware.com/cmake/cmake/-/issues/16414
if (TARGET basix)
  add_library(Basix::basix ALIAS basix)
else()
  # Find Basix (C++)
  find_package(Basix REQUIRED)
endif()

# Correct COMPONENT specification Development.Module added only in CMake 3.18
# and above.
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.18.0")
  find_package(Python3 COMPONENTS Interpreter Development.Module REQUIRED)
else()
  find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
endif()

if(SKBUILD)
  # Scikit-Build does not add your site-packages to the search path
  # automatically, so we need to add it or the pybind11 specific
  # directory here.
  execute_process(
    COMMAND
      "${Python3_EXECUTABLE}" -c
      "import pybind11; print(pybind11.get_cmake_dir())"
    OUTPUT_VARIABLE _tmp_dir
    OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)
  list(APPEND CMAKE_PREFIX_PATH "${_tmp_dir}")
endif()

find_package(pybind11 REQUIRED CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})

# Create the binding library
pybind11_add_module(_basixcpp MODULE wrapper.cpp)
target_link_libraries(_basixcpp PRIVATE Basix::basix)

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror  -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment;-pedantic)
endif()

# In Debug mode override pybind11 symbols visibility. Symbols must be
# visible to backtrace_symbols() to produce nice logs
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  target_compile_options(_basixcpp PRIVATE "-fvisibility=default")
endif()

# scikit-build specific steps
if (SKBUILD)
  # Add relative rpath so _basixcpp can find the Basix::basix libray
  # when the build is relocated
  if (APPLE)
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "@loader_path/lib")
  else()
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
  endif()

  install(TARGETS _basixcpp DESTINATION .)
endif()

=== test/test_cmake/CMakeLists.txt ===
# Example of CMakeLists.txt for downstream C++ project (eg DOLFINx)
# Used to check correctly installed package during wheel creation.:
cmake_minimum_required(VERSION 3.16)

project(basix_test)

# Use Python for detecting Basix
find_package(Python3 COMPONENTS Interpreter REQUIRED)

# From DOLFINx
execute_process(
  COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
  OUTPUT_VARIABLE BASIX_PY_DIR
  RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if (BASIX_PY_DIR)
  message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
  # Lines below are when using pip-installed Basix
  set(xtl_ROOT "${BASIX_PY_DIR};${xtl_ROOT}")
  set(xsimd "${BASIX_PY_DIR};${xsimd_ROOT}")
  set(xtensor_ROOT "${BASIX_PY_DIR};${xtensor_ROOT}")
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

get_target_property(BASIX_DEFN Basix::basix INTERFACE_COMPILE_DEFINITIONS)
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN)
  find_package(xsimd REQUIRED)
endif()

add_executable(a.out main.cpp)
if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(a.out PRIVATE Basix::basix)

=== demo/cpp/demo_create_and_tabulate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_create_and_tabulate LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Basix REQUIRED)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== demo/cpp/demo_dof_transformations/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_dof_transformations LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Basix REQUIRED)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== debian/changelog ===
fenics-basix (0.4.2-6) unstable; urgency=medium

  * use epoch with ffcx version.
    python3-basix Breaks: python3-ffcx (<< 1:0.4~)

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Jul 2022 22:17:23 +0200

fenics-basix (0.4.2-5) unstable; urgency=medium

  * python3-basix Breaks: python3-ffcx (<< 0.4~)
    to facilitate migration to testing

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Jul 2022 11:03:17 +0200

fenics-basix (0.4.2-4) unstable; urgency=medium

  * set libbasix-dev Depends: libxtensor-dev, libxsimd-dev with
    versions that basix was built against.

 -- Drew Parsons <dparsons@debian.org>  Wed, 29 Jun 2022 18:32:41 +0200

fenics-basix (0.4.2-3) unstable; urgency=medium

  * add arm64 to list of xsimd-supported architectures.
    Should run fine with xsimd 0.8.1-3 and xtensor 0.24.
    armhf and i386 still fail xsimd tests so don't add them yet.
    Closes: #1013626.

 -- Drew Parsons <dparsons@debian.org>  Sat, 25 Jun 2022 13:04:28 +0200

fenics-basix (0.4.2-2) unstable; urgency=medium

  * push FEniCS-x 0.4 to unstable

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Jun 2022 12:45:08 +0200

fenics-basix (0.4.2-1exp2) experimental; urgency=medium

  * build python module also in arch-indep builds to enable doc build
    Closes: #1012022.

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Jun 2022 11:13:03 +0200

fenics-basix (0.4.2-1exp1) experimental; urgency=medium

  * New upstream release.
    - versioned Build-Depends: libxtensor-dev (>= 0.23.10~)
  * Build-Depends: python3-ufl not python3-fiat (used in tests)

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 May 2022 18:49:49 +0200

fenics-basix (0.4.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - drop Build-Depends: libxtensor-blas-dev
    - add Build-Depends: libblas-dev, liblapack-dev (or alternatives)
  * bump library soname to libbasix0.4
  * drop redundant debian patch build_any_xtensor.patch
  * debian/rules: use execute_after[before] instead of override_
  * debian patch python_cmake_options.patch enables extra cmake
    options to be provided to a standalone build of the python module
    i.e. to provide XTENSOR configuration to be consistent with the
    C++ library configuration.
  * update debian patch fix_doc_build.patch to build docs using
    local mathjax
  * point debian/pybuild.testfiles at test dir to enable pybuild tests
    for all supported python versions
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 May 2022 13:10:24 +0200

fenics-basix (0.3.0-12) unstable; urgency=medium

  * switch off all numba tests until numba is again available
    (currently removed due to python3.10 incompatibility)
    Closes: #1008522.

 -- Drew Parsons <dparsons@debian.org>  Fri, 01 Apr 2022 16:49:42 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,7 @@
  dh-python,
  python3-setuptools,
  python3-all-dev:any,
- python3-fiat,
- python3-numba [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64],
+ python3-ufl,
  python3-numpy,
  python3-pybind11 (>= 2.6.0~),
  python3-pytest,
@@ -21,12 +20,13 @@
  libeigen3-dev,
  libjs-mathjax,
  ninja-build,
- libxtensor-dev (>= 0.23.4~),
- libxtensor-blas-dev (>= 0.19~),
- libxsimd-dev (>= 7.4.10~) [amd64 kfreebsd-any],
+ libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
+ liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
+ libxtensor-dev (>= 0.23.10~),
+ libxsimd-dev (>= 7.4.10~) [amd64 arm64 kfreebsd-any],
  xtl-dev (>= 0.7.0~)
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/FEniCS/basix
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
 Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
@@ -36,8 +36,10 @@
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0 (= ${binary:Version}),
+Depends: libbasix0.4 (= ${binary:Version}),
  libeigen3-dev,
+ libxtensor-dev (>= ${xtensor:Upstream-Version}~),
+ libxsimd-dev (>= ${xsimd:Upstream-Version}~) [amd64 arm64 kfreebsd-any],
  ${misc:Depends}, ${shlibs:Depends}
 Suggests: python3-basix, basix-doc
 Description: Finite Element Basis Function Definition Runtime Library (development headers)
@@ -60,7 +62,7 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0
+Package: libbasix0.4
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -90,6 +92,7 @@
 Depends: libbasix-dev  (= ${binary:Version}),
  ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-numba
+Breaks: python3-ffcx (<< 1:0.4~)
 Suggests: basix-doc
 Description: Finite Element Basis Function Definition Runtime Library (Python 3)
  Computes FE basis functions and derivatives for the following

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_HOST_MULTIARCH

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

VERSION := $(DEB_STRIPPED_UPSTREAM_VERSION)
MAJOR_VERSION := $(shell echo $(DEB_STRIPPED_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
SOVERSION := $(MAJOR_VERSION)

XTENSOR_DEB_VERSION=$(shell dpkg -s libxtensor-dev | awk '/Version:/ {print $$2}')
XTENSOR_VERSION=$(shell echo $(XTENSOR_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")

XSIMD_DEB_VERSION=$(shell dpkg -s libxsimd-dev | awk '/Version:/ {print $$2}')
XSIMD_VERSION=$(shell echo $(XSIMD_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")

PY3VERS := $(shell py3versions -v --requested debian/control | tac -s' ')
PY3VER_DEFAULT := $(shell py3versions -dv)

empty :=
space := $(empty)$(empty)

# libxsimd-dev is available on some arches such as i386, m68k,
# but no xsimd instructions are actually available which causes problems
# with the basix build (warnings are treated as errors)
# So explicitly switch xsimd support off except for arches where it is known to work.
XSIMD_ARCH_LIST := amd64 arm64 kfreebsd
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(XSIMD_ARCH_LIST)$(space)))
  XSIMD_CONFIG = -DXTENSOR_USE_XSIMD=ON
else
  XSIMD_CONFIG = -DXTENSOR_USE_XSIMD=OFF
endif

#ifneq (,$(findstring $(DEB_HOST_ARCH),mipsel))
  PYTEST_OPTIONS = -k "not numba"
#endif


%:
	dh $@ --with python3,sphinxdoc --buildsystem=cmake


override_dh_auto_clean:
	rm -rf cpp/basix/version.h
	rm -rf doc/cpp/html doc/cpp/latex
	rm -rf .pybuild
	rm -rf python/build
	rm -rf python/fenics_basix.egg-info
	rm -rf doc/python/build
	rm -rf test/.pytest_cache  test/__pycache__  python/testing_build
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure --sourcedir=cpp -- $(XSIMD_CONFIG)

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build --sourcedir=cpp -i
	cd doc/cpp; doxygen

execute_after_dh_auto_install:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake \
	  pybuild --dir=$(CURDIR)/python --system=distutils --name=basix \
	  --configure-args "setopt --command=build_ext --option=extra_cmake_args --set-value='$(XSIMD_CONFIG)'"

execute_before_dh_install-indep:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} $(MAKE) -C doc/python html
	sed 's|href="https://fenicsproject.org/docs/basix/main/cpp/"|href="file:/usr/share/doc/basix-doc/cpp/index.html"|' -i doc/python/build/html/index.html

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_before_dh_python3:
	cd test; LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} pytest-3 $(PYTEST_OPTIONS)
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vxtensor:Upstream-Version=$(XTENSOR_VERSION) -Vxsimd:Upstream-Version=$(XSIMD_VERSION)
